package org.yoshiori.llspirit;

import javafx.ui.*;
import javafx.ui.canvas.*;
import javafx.ui.filter.*;

import java.lang.System;
import java.lang.Math;

import java.awt.Toolkit;

public class Template extends BaseView {
  public attribute title: String;
  public attribute name: String;
  public attribute opacityValue: Number;
  public attribute font: Font;
  public attribute content: Content;
}
attribute Template.title =  "VMɓĖႦȂJavaFXScript()";
attribute Template.name = "Yoshiro SHOJI(http://yoshiori.org/)";
attribute Template.opacityValue = bind Math.abs(([ -100..100 ] dur 10000 linear continue if true) / 100 );
attribute Template.font = Font { face: bind fontFace, size: height / 20 };

function stringWidth( font:Font, text ){
  return Toolkit.getDefaultToolkit().getFontMetrics( font.getFont() ).stringWidth(text);
}

operation Template.composeNode(){
  return Group {
    content:[ 
      Rect {
        width: width
        height: height/10
        fill: rgb:Color(102,0,0)
        opacity: bind opacityValue 
        x: 0
        y: 0
      },
      Rect {
        width: width
        height: height/10
        fill: rgb:Color(102,0,0)
        opacity: bind opacityValue
        x: 0
        y: height - height/10
      },
      Text {
        content: title
        x:10
        y:(height / 20)/2
        font: font
        fill:white
      },
      Text {
        content: name
        x: 250 
        y: height - height/10 + (height / 20)/2
        font: font
        fill:white
      },
      Group{ content: bind content },
      NiconicoView
    ]
  };
}
