package org.yoshiori.llspirit;

import javafx.ui.*;
import javafx.ui.canvas.*;
import javafx.ui.filter.*;

import java.lang.Math;
import java.lang.System;

import org.yoshiori.lingr.api.Message;
import org.yoshiori.lingr.bot.LingrBot;
import org.yoshiori.lingr.bot.ObserverListener;
import org.yoshiori.lingr.api.vo.ClientType;
import org.yoshiori.lingr.api.vo.MessageType;

public class NiconicoView extends BaseView {
  public attribute texts : NiconicoText*;
}
operation NiconicoView.composeNode(){
  return Group{
          content: bind texts
  };
}
trigger on new NiconicoView{
  var nicoView = this;
  var bot = new LingrBot("yoshiori_bot", "ll-spirit", "86f98e18c21048c099cf07ee6c250f1e");
  bot.addListener(new ObserverListener(){
    operation observe(bot,event){  
      try{
        //for(i:Message in event.getMessages()){
        //  System.out.println(i);
        //}
        var message = ((Message)event.getMessages().toArray()[0]);
        System.out.println(message.getType());
        if(message.getClientType() == HUMAN:ClientType and message.getType() == USER:MessageType){
          do later{
            insert NiconicoText{comment:"{message.getNickname()}:{message.getText()}"} into nicoView.texts;
          }
        }
      }catch(any){
        System.out.println("catch:{any}");
      }
    }
  });
  bot.start();
}

public class NiconicoText extends CompositeNode {
  public attribute comment : String;
  public attribute dx : Number;
  public attribute dy : Number;
  
  public attribute dfont : Font;
  public attribute backfont : Font;
}

operation NiconicoText.composeNode(){
  return Group {
    content: [ 
      Text{
        content: bind comment
        x: bind dx
        y: bind dy
        font: bind backfont
      },
      Text{                                   
        content: bind comment
        x: bind dx
        y: bind dy
        font: bind dfont
        fill: white 
      }
    ]
  };  
}

trigger on insert niconicoText into NiconicoView.texts {
  niconicoText.dfont = Font { face: bind fontFace, size: bind height / 10 };
  niconicoText.backfont = Font { face: bind fontFace, style:bold:FontStyle, size: bind height / 10 + 2};
  niconicoText.dy = Math.random() * (height - niconicoText.dfont.size);
  niconicoText.dx = [width..-niconicoText.comment.length() * niconicoText.dfont.size ] dur 5000 linear;
}

